## Welcome to our repository, contributor!
### If you want to contribute, please read text below. Thank you.
***


## Variables
* All global variables must be named using upper case, just like: `EXAMPLE_VARIABLE, VERY_IMPORTANT_VARIABLE, ANOTHER_ONE` 

* All local variables must be named using lower case, just like: `example_variable, very_important_variable, another_one`

* All variables must have good readable names.

Variables | Example
-- | --
Good | `employees_count, user_month_work_days_count, YEAR_TAX, MAX_COMPUTED_SALARY`
Bad | `x, $fb, f_ar_type_data, f_obj_result, inputData, returnValue, resultArray, obj1, obj2`

## Functions
* Every function must be named like this: `exampleFunction, veryImportantFunction, justAnotherExample`

* All functions must have good readable names.

Functions | Example
-- | --
Good | `getFullName(), createUser(), startSession(), removeLayer()`
Bad | `getFullNameAndUserID(), calculateVariable(), abcdeFG(), redBug()`

## Classes
* Every class must be named like this: `ExampleClass, VeryImportantClass, JustAnotherClass`
* All classes must have good readable names.

Classes | Example
-- | --
Good | `UserMapper, SystemLoader, PlayerBase, Logger, Scheduler`
Bad | `ABCDEFG, ClassForAllProject, JustMathClass, AllInOneClass`
